//////LIBRARIES
#include <plib.h> // for PIC specific functions
#include "NU32.h" // for NU32 board specific functions

//////GLOBAL VARIABLES

//////FUNCTION PROTOTYPES

//////MAIN
int main(void)
{
    startup(); // from NU32.c, maximizes performance
    initialize(); // from NU32.c, inits USER, L1 and L2, serial fns

    // infinite loop
    while(1)
    {
        // nothing, do everything in the UART1 ISR
    }
    return 0;
}

//////FUNCTIONS

//////ISRs
// interrupt when the NU32 gets a character from the computer
void __ISR(_UART_1_VECTOR, ipl2) IntUart1Handler(void)
{
    int i = 0;

    // Is this an RX interrupt?
    if(INTGetFlag(INT_SOURCE_UART_RX(UART1)))
    {
        // read the byte
        char data = UARTGetDataByte(UART1);

        // if the byte is an 'a', send back 0-9
        if (data == 'a') {
            for (i=0; i<10; i++) {
                sprintf(RS232_Out_Buffer,"%d\r\n", i);
                WriteString(UART1, RS232_Out_Buffer);
            }
        }

        // Clear the RX interrupt Flag
        INTClearFlag(INT_SOURCE_UART_RX(UART1));
    }

    // We don't care about TX interrupt
    if(INTGetFlag(INT_SOURCE_UART_TX(UART1)))
    {
        INTClearFlag(INT_SOURCE_UART_TX(UART1));
    }
}

